> ## Documentation Index
> Fetch the complete documentation index at: https://www.osohq.com/docs/llms.txt
> Use this file to discover all available pages before exploring further.

# Post actions query



## OpenAPI

````yaml /reference/openapi.json post /actions_query
openapi: 3.1.0
info:
  title: Oso Cloud HTTP API
  version: 0.1.0
  description: >-
    <p>Oso Cloud exposes an HTTP API that you can use to make queries directly,
    without using one of the clients.</p><p>For endpoints that require
    authentication, pass your API key as an HTTP Bearer Auth payload.</p><p>For
    example, using curl: <code>curl -H &quot;Authorization: Bearer
    $OSO_AUTH&quot; https://cloud.osohq.com/api/</code></p>
servers:
  - url: https://api.osohq.com/api/
security: []
paths:
  /actions_query:
    post:
      tags:
        - Local Check API
      operationId: post_actions_query
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/LocalActionsQuery'
        required: true
      responses:
        '200':
          description: ''
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/LocalActionsResult'
        default:
          description: ''
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ApiError'
      security:
        - ApiKey: []
      x-codeSamples:
        - lang: javascript
          label: Node.js
          source: |
            import { Oso } from 'oso-cloud';

            const apiKey = process.env.OSO_CLOUD_API_KEY;
            const oso = new Oso("https://cloud.osohq.com", apiKey);

            // Generate actions query SQL
            const alice = { type: "User", id: "alice" };
            const issue = { type: "Issue", id: "123" };
            const query = await oso.actionsLocal(alice, issue);

            // Execute with database
            const result = await sql.raw(query).execute(db);
            const actions = result.rows.map(row => row.actions);

            console.log("Available actions:", actions);
        - lang: python
          label: Python
          source: |
            from oso_cloud import Oso, Value
            import os
            from sqlalchemy import text
            from oso_cloud import Oso, Value

            oso = Oso(api_key=os.environ.get('OSO_CLOUD_API_KEY', None))

            # Generate actions query SQL
            alice = Value("User", "alice")
            issue = Value("Issue", "123")
            query = oso.actions_local(alice, issue)

            # Execute with SQLAlchemy
            actions = list(session.execute(text(query)).scalars())

            print(f"Available actions: {actions}")
        - lang: go
          label: Go
          source: |
            package main

            import (
                "log"
                "os"
                oso "github.com/osohq/go-oso-cloud/v2"
            )

            func main() {
                apiKey := os.Getenv("OSO_CLOUD_API_KEY")
                osoClient := oso.NewClient("https://cloud.osohq.com", apiKey)

                // Generate actions query SQL
                alice := oso.NewValue("User", "alice")
                issue := oso.NewValue("Issue", "123")
            query, err := osoClient.ActionsLocal(alice, issue)
            if err != nil {
                log.Fatal(err)
            }

            // Execute with GORM
            var actions []string
            db.Raw(query).Pluck("actions", &actions)

            fmt.Printf("Available actions: %v\n", actions)
            }
        - lang: java
          label: Java
          source: |
            package com.mycompany;

            import java.io.IOException;
            import java.util.List;
            import com.osohq.oso_cloud.Oso;
            import com.osohq.oso_cloud.api.ApiException;
            import com.osohq.oso_cloud.api.Value;

            public class App {
                public static void main(String[] args) {
                    String apiKey = System.getenv("OSO_CLOUD_API_KEY");
                    Oso oso = new Oso(apiKey);
                    
                    try {
                        // Generate actions query SQL
                        Value alice = new Value("User", "alice");
                        Value issue = new Value("Issue", "123");
                        String query = oso.actionsLocal(alice, issue);
                        
                        // Execute with database (example with JPA/Hibernate)
                        List<String> actions = entityManager.createNativeQuery(query)
                            .getResultList();
                        
                        System.out.println("Available actions: " + actions);
                    } catch (IOException | ApiException e) {
                        System.err.println("Error: " + e.getMessage());
                    }
                }
            }
        - lang: ruby
          label: Ruby
          source: >
            require 'oso-cloud'


            api_key = ENV.fetch('OSO_CLOUD_API_KEY', nil)

            oso = OsoCloud::Oso.new(url: "https://cloud.osohq.com", api_key:
            api_key)


            # Generate actions query SQL

            alice = OsoCloud::Value.new(type: "User", id: "alice")

            issue = OsoCloud::Value.new(type: "Issue", id: "123")

            query = oso.actions_local(alice, issue)


            # Execute with ActiveRecord

            actions =
            ActiveRecord::Base.connection.execute(query).values.flatten


            puts "Available actions: #{actions}"
        - lang: csharp
          label: C#
          source: >
            using OsoCloud;

            using System.Data;


            string? apiKey =
            Environment.GetEnvironmentVariable("OSO_CLOUD_API_KEY");

            var oso = new Oso("https://api.osohq.com", apiKey);


            // Generate actions query SQL

            var alice = new Value("User", "alice");

            var issue = new Value("Issue", "123");

            string query = await oso.ActionsLocal(alice, issue);


            // Execute with Entity Framework

            var actions = await
            context.Database.SqlQueryRaw<string>(query).ToListAsync();


            Console.WriteLine($"Available actions: {string.Join(", ",
            actions)}");
components:
  schemas:
    LocalActionsQuery:
      type: object
      required:
        - data_bindings
        - query
      properties:
        query:
          $ref: '#/components/schemas/ActionsQuery'
        data_bindings:
          type: string
    LocalActionsResult:
      type: object
      required:
        - sql
      properties:
        sql:
          type: string
    ApiError:
      type: object
      required:
        - message
      properties:
        message:
          type: string
    ActionsQuery:
      type: object
      required:
        - actor_id
        - actor_type
        - resource_id
        - resource_type
      properties:
        actor_type:
          type: string
        actor_id:
          type: string
        resource_type:
          type: string
        resource_id:
          type: string
        context_facts:
          default: []
          type: array
          items:
            $ref: '#/components/schemas/Fact'
    Fact:
      description: 'A pattern object for matching authorization-relevant data, ie: facts.'
      type: object
      required:
        - args
        - predicate
      properties:
        predicate:
          type: string
        args:
          type: array
          items:
            $ref: '#/components/schemas/Value'
    Value:
      type: object
      properties:
        type:
          type: string
          nullable: true
        id:
          type: string
          nullable: true
  securitySchemes:
    ApiKey:
      description: Requires an API key to access.
      type: http
      scheme: bearer
      bearerFormat: Bearer e_0123_123_token0123

````